=== debian/changelog ===
hdf5 (1.8.13+docs-15ubuntu2) wily; urgency=medium

  * Fix up dependencies of libhdf-dev for the libhdf5-cpp-8v5 name change.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 22:16:00 +0000

hdf5 (1.8.13+docs-15ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.
  * Fix up debian/libhdf5-cpp-8v5.symbols as much as possible; mark
    appropriate (new) symbols as non-optional, instead of the existing
    convention of all C++ symbols being marked as optional, despite the fact
    that dpkg-gensymbols still won't be treated as a build failure.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 04:34:31 +0000

hdf5 (1.8.13+docs-15) unstable; urgency=medium

  * New patch HDFFV-8917.patch from upstream to fix a resource
    exhaustion bug (closes: #765511).

 -- Gilles Filippini <pini@debian.org>  Fri, 17 Oct 2014 07:51:24 +0200

hdf5 (1.8.13+docs-14) unstable; urgency=medium

  * Use legacy library names in pkg-config files, to be consistent with
    h5cc & co.

 -- Gilles Filippini <pini@debian.org>  Sun, 05 Oct 2014 20:57:39 +0200

hdf5 (1.8.13+docs-13) unstable; urgency=medium

  * Revert libhdf5-mpi-dev to arch any, because the dependency depends
    on the architecture (thanks to Anton Gladky).
  * d/control clean-up:
    - remove Sylvestre from the uploaders (at his request)
    - drop un-needed build-deps:
      . libopenmpi-dev (pulled in by mpi-default-dev)
      . libibverbs (pulled in by libopenmpi-dev)
      . sed (essential, and version >= 4.1.5 in old-stable).

 -- Gilles Filippini <pini@debian.org>  Tue, 16 Sep 2014 09:52:37 +0200

hdf5 (1.8.13+docs-12) unstable; urgency=medium

  * Set up debian/libhdf5-mpi-dev.substvars in the binary-indep target
    because release 1.8.13+docs-10 changed the libhdf5-mpi-dev
    architecture to 'all'.

 -- Gilles Filippini <pini@debian.org>  Fri, 12 Sep 2014 11:02:24 +0200

hdf5 (1.8.13+docs-11) unstable; urgency=medium

  * Fix wrong path in h5fc part of flavor-configure-option.patch
    (closes: #761244).

 -- Gilles Filippini <pini@debian.org>  Fri, 12 Sep 2014 08:01:30 +0200

hdf5 (1.8.13+docs-10) unstable; urgency=medium

  * Clean-up d/control
  * Allow disabling the MPI targets at build time (closes: #576004).
    This is triggered by setting empty environment variables OMPIARCHS
    and MPICHARCHS.

 -- Gilles Filippini <pini@debian.org>  Thu, 11 Sep 2014 10:10:38 +0200

hdf5 (1.8.13+docs-9) unstable; urgency=medium

  * Sync $(ARCH) with arch list from openmpi package (closes: #744963).
  * Enable the Fortran 2003 interface (closes: #758694).

 -- Gilles Filippini <pini@debian.org>  Fri, 05 Sep 2014 20:04:12 +0200

hdf5 (1.8.13+docs-8) unstable; urgency=medium

  * Add lintian overrides for libhdf5*-dev to ignore the warning
    symlink-is-self-recursive.

 -- Gilles Filippini <pini@debian.org>  Fri, 15 Aug 2014 22:37:03 +0200

hdf5 (1.8.13+docs-7) experimental; urgency=medium

  * libhdf5-*-dev: add a link to have libhdf5.settings into
    /usr/lib/$MULTIARCH/hdf5/$flavor/.

 -- Gilles Filippini <pini@debian.org>  Tue, 12 Aug 2014 22:28:52 +0200

hdf5 (1.8.13+docs-6) experimental; urgency=medium

  * Add alternatives for hdf5.pc in -dev packages.

 -- Gilles Filippini <pini@debian.org>  Thu, 31 Jul 2014 15:33:46 +0200

hdf5 (1.8.13+docs-5) experimental; urgency=medium

  * Fix to the previous fix: forgot to update d/control.in.

 -- Gilles Filippini <pini@debian.org>  Wed, 30 Jul 2014 09:59:50 +0200

hdf5 (1.8.13+docs-4) experimental; urgency=medium

  * libhdf5-{openmpi,mpich}-dev: drop dependency on hdf5-helpers
    so that h5cc isn't in the way of the cmake FindHDF5 macro.

 -- Gilles Filippini <pini@debian.org>  Tue, 29 Jul 2014 19:25:41 +0200

hdf5 (1.8.13+docs-3) experimental; urgency=medium

  * Fix h5cc and co helpers so that they don't break the cmake macro
    FindHDF5.cmake:
    - search libraries with their legacy names into
      /usr/lib/$MULTIARCH/hdf5/$flavor/
    - insert -I$includedir into the result of the -show option

 -- Gilles Filippini <pini@debian.org>  Thu, 24 Jul 2014 12:02:57 +0200

hdf5 (1.8.13+docs-2) experimental; urgency=medium

  * Add lib and include links into /usr/lib/$MULTIARCH/hdf5/$flavor/
    so that reverse build dependencies could use:
    --with-hdf5=/usr/lib/$MULTIARCH/hdf5/$flavor

 -- Gilles Filippini <pini@debian.org>  Tue, 15 Jul 2014 11:30:46 +0200

hdf5 (1.8.13+docs-1) experimental; urgency=medium

  [Gilles Filippini]
  * New upstream release
  * MPI-POSIX driver removed by upstream. Applications performing parallel
    I/O should use the MPI-IO driver, H5Pset_fapl_mpio
  * SONAME bump to 8

  * Repack upstream docs:
    - Drop useless MacOS resource fork file
    - Drop generated files:
      . Generate C++ doc at build time with doxygen
      . Process PHP scriptlets in HTML files at build time
    - Build-Depends: doxygen, php5-cli
  * debian/watch: use dversionmangle to correctly match upstream releases
  * libhdf5-doc: drop dependency on libjs-jquery (not needed anymore)
  * debian/source.lintian-overrides: ignore lintian warnings related to
    the mpich2 dummy transitional packages
  * Add manpages for h5pcc, h5pfc and h5debug (generated with help2man)

  * Make serial and $mpi flavors co-installable
    - New patch flavor-configure-option.patch: add option --with-flavor
      which append '_<flavor-name>' to the libraries' names
    - Configure builds with flavor-name={serial,openmpi,mpich}
    - link $flavor development libs to
      /usr/lib/$MULTIARCH/hdf5/$flavor/libhdf5-<legacy-names> (so that existing
      makefiles still work using -L/usr/lib/$MULTIARCH/hdf5/$flavor)
    - install $flavor include files into /usr/include/hdf5/$flavor (so
      that existing makefiles still work using -I/usr/include/hdf5/$flavor)
    - Use alternatives to choose default h5p{cf}c
    - Deactivate patch skip_cxx_inclusion.diff
    - Remove related Conflicts / Provides from debian/control*

